Subject: bug#25937: closed (Re: bug#25937: luks mapped-devices does not support multiple mapped-devices)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 18 Aug 2021 03:03:02 +0000

Your bug report

#25937: luks mapped-devices does not support multiple mapped-devices

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
25937: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=25937
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#25937: luks mapped-devices does not support multiple mapped-devices
From: Maxim Cournoyer <[email-masked]>
To: zimoun <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Tue, 17 Aug 2021 23:02:11 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

zimoun <[email-masked]> writes:

> Dear,
>
> Digging in the bug tracker, I found this bug report [1]. What is its status?
> Is it solved for you?
>
> Best regards,
> simon
>
> [1] https://debbugs.gnu.org/cgi/bugreport.cgi?bug=25937

Recopying the content here for ease of reference:

> upon trying to create a system with multiple mapped-devices the
> current documentation about mapped-devices doesn't help me anymore.

> So far I'm just trying with two luks devices, I'll get RAID in there as
> a third device later.
> So this part in a config.scm:

>   (mapped-devices
>    (list (mapped-device
>           (source (uuid "fooooo1233333333333333333"))
>           (target "my-root")
>           (type luks-device-mapping))
>          (mapped-device
>            (source (uuid "fooooo124444444444444444"))
>            (target "dg2")
>            (type luks-device-mapping))))

>   (file-systems (cons* (file-system
>                         (device "my-root")
>                         (title 'label)
>                         (mount-point "/")
>                         (type "ext4")
>                         (dependencies mapped-devices))
>                       (file-system
>                         (device "/dev/sdb1")
>                         (title 'device)
>                         (mount-point "/mnt/dg1")
>                         (type "ext4"))
>                       (file-system
>                         (device "dg2")
>                         (title 'label)
>                         (mount-point "/mnt/dg2")
>                         (type "ext4")
>                         (dependencies mapped-devices))
>                       %base-file-systems))
>
> ...fails with this error:

> address@hidden ~$ guix system build /etc/config.scm

> guix system: error: service 'file-system-/mnt/dg2' requires
> 'device-mapping-my-root', which is not provided by any service

> How do I fix this?

>From info "(guix)File Systems":

     When the source of a file system is a mapped device (*note
     Mapped Devices::), its ‘device’ field _must_ refer to the
     mapped device name—e.g., ‘"/dev/mapper/root-partition"’.  This
     is required so that the system knows that mounting the file
     system depends on having the corresponding device mapping
     established.

So it seems that you must provide "/dev/mapper/my-root" instead of
referring to it by label.  Although, I was able to reconfigure with the
following mapped devices/file systems:

--8<---------------cut here---------------start------------->8---
    (mapped-devices
     (list (mapped-device
            (source (uuid "0792432c-78d8-4dcc-87c5-30200c3d02db");"/dev/sda2"
                    )
            (target "cryptroot")
            (type luks-device-mapping))
           (mapped-device
            (source (uuid "a9aead40-9d01-4f7a-bb83-be70dd192b7b");"/dev/sdb2"
                    )
            (target "cryptroot-mirror")
            (type luks-device-mapping))
           (mapped-device
            (source (uuid "f0afd5c9-da70-46a7-9c6f-5d22913638bf");"/dev/sdc2"
                    )
            (target "cryptroot-mirror2")
            (type luks-device-mapping))))

    ;; Note: Using any of the LUKS encrypted drives exposed under
    ;; /dev/mapper is enough to reference the Btrfs RAID-1 array,
    ;; since the 'btrfs device scan' command is executed in the init
    ;; RAM disk and takes care of assembling the array.
    (file-systems (cons* (file-system
                           (mount-point "/")
                           (device (file-system-label "my-root"))
                           (type "btrfs")
			   (options (alist->file-system-options
                                     (cons '("subvol" . "@root")
                                           %common-btrfs-options)))
			   (dependencies mapped-devices))
                         (file-system
                           (device "/dev/mapper/cryptroot-mirror")
                           (mount-point "/home")
                           (type "btrfs")
                           (options (alist->file-system-options
                                     (cons '("subvol" . "@home")
                                           %common-btrfs-options)))
                           (dependencies mapped-devices))
                         (file-system
                           (device "/dev/mapper/cryptroot-mirror2")
                           (mount-point "/data")
                           (type "btrfs")
                           (options (alist->file-system-options
                                     (cons '("subvol" . "@data")
                                           %common-btrfs-options)))
                           (dependencies mapped-devices))
                         %base-file-systems))
--8<---------------cut here---------------end--------------->8---
                         
So perhaps that particular limitation has been lifted, or perhaps Btrfs
is different in this regard.

I'll close the bug, but feel free to reopen it if you still have
problems.

Thank you,

Maxim

Subject: luks mapped-devices does not support multiple mapped-devices
From: ng0 <[email-masked]>
To: [email-masked]
Date: Thu, 2 Mar 2017 16:21:19 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

While I'm trying to solve this[0] issues, rekado suggested to either use
a let or a define for the initial error I encountered.

This lead to the system config which can be seen here:
http://paste.lisp.org/display/340362#1 , still resulting in error:

user@greendragon ~$ guix system build /etc/config.scm                                                                              
guix system: error: service 'file-system-/mnt/dg2' requires
'file-system-/', which is not provided by any service

My guess is that mapped-devices does not consider cases where more than
one luks-device is present. I haven't tried the final use-case yet which
is bringing raid-mapped-devices in there, I expect this not to happen
before this issue is fixed, to have isolated and not multiple causes of
failure/errors.

Should the lisp.org paste disappear I can append my system config, for
now the paste is enough.

0: https://lists.gnu.org/archive/html/guix-devel/2017-03/msg00024.html